config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  resources :mail_bodies
  resources :public_templates

  resources :projects do
    resources :transactions
    resources :templates
    resources :sending_emails
    resources :sending_providers_projects
  end

  root to: 'application#home'
  devise_for :users, :controllers => {:registrations => "registrations"}
  resources :users

  # pages
  get 'home', to: 'application#home'
  get '/dev_mailbox', to: 'dev_mailbox#index'
  get '/projects/:project_id/confirm_sending_emails', to: 'sending_emails#confirm_email'
  get '/projects/:project_id/sending_emails/:id/resend_confirmation', to: 'sending_emails#resend_confirmation'
  get '/projects/:project_id/transactions/:id/design', to: 'transactions#design'
  get '/projects/:id/api_security', to: 'projects#api_security'
  get '/projects/:project_id/create_from_provider/:sending_provider_id', to: 'sending_providers_projects#create_from_provider'

  # vue widget Api
  scope '/projects/:project_id/widjet/v1' do
    # designer endpoint
    scope '/designer' do
      post '/preview', to: 'api/widjet/designer#preview'
      post '/:designable_type/:id/upload_picture_asset', to: 'api/widjet/designer#create_local_picture_asset'
      post '/upload_picture_asset', to: 'api/widjet/designer#create_global_picture_asset'
      patch '/:designable_type/:id', to: 'api/widjet/designer#update_designable'
      delete '/delete_asset/:sendable_asset_id', to: 'api/widjet/designer#destroy_asset'
    end

    # Api security endpoint
    scope '/api_security' do
      post '/create_key/:env', to: 'api/widjet/api_security#generate_key'
      patch '/change_locks/:id', to: 'api/widjet/api_security#change_locks'
    end
  end

  # client Api endpoints
  scope '/v1', defaults: {format: :json} do
    post '/transmit/:code_name', to: 'api/v1/transmit_api#transmit_transaction'
  end


end

app/models/sending_providers_project.rb
class SendingProvidersProject < ApplicationRecord
  belongs_to :sending_provider
  belongs_to :project
  has_many :provider_key_values, dependent: :destroy

  validates :project, uniqueness: { scope: :sending_provider }
  include DefaultyWrapper

  accepts_nested_attributes_for :provider_key_values, reject_if: :all_blank, allow_destroy: false

  def keys
    sending_provider.keys
  end

  def new_values_for_keys
    self.keys.map do |key|
      ProviderKeyValue.find_by(sending_providers_project: self, sending_provider_key: key) || ProviderKeyValue.new(sending_providers_project: self, sending_provider_key: key)
    end
  end

  def get_credentials
    creds = {"provider" => self.sending_provider.name}
    self.keys.each do |k|
      creds[k.key_name] = ProviderKeyValue.find_by(sending_provider_key: k, sending_providers_project: self).value
    end
    return creds
  end

end

app/controllers/sending_providers_projects_controller.rb
class SendingProvidersProjectsController < ProjectChildrenController
  before_action :set_sending_providers_project, only: [:show, :edit, :update, :destroy]
  layout "projects"
  # GET /sending_providers_projects
  # GET /sending_providers_projects.json
  def index
    @sending_providers_projects = @project.sending_providers_projects
    @unused_services = @project.unused_smtp_providers
  end

  # GET /sending_providers_projects/1
  # GET /sending_providers_projects/1.json
  def show
  end

  # GET /sending_providers_projects/new
  def new
    @sending_providers_project = SendingProvidersProject.new(sending_providers_project_params)
  end

  def create_from_provider
    @sending_providers_project = @project.sending_providers_projects.build({sending_provider_id: params[:sending_provider_id]})

    respond_to do |format|
      if @sending_providers_project.save
        format.html { redirect_to edit_project_sending_providers_project_path(@project, @sending_providers_project), notice: 'Sending services project was successfully created.' }
        format.json { render :show, status: :created, location: @sending_providers_project }
      else
        format.html { redirect_to project_sending_providers_projects_path(@project), warn: 'not created' }
        format.json { render json: @sending_providers_project.errors, status: :unprocessable_entity }
      end
    end
  end

  # GET /sending_providers_projects/1/edit
  def edit
  end

  # POST /sending_providers_projects
  # POST /sending_providers_projects.json
  def create
    @sending_providers_project = SendingProvidersProject.new(sending_providers_project_params)

    respond_to do |format|
      if @sending_providers_project.save
        format.html { redirect_to project_sending_providers_projects_path(@project), notice: 'Sending services project was successfully created.' }
        format.json { render :show, status: :created, location: @sending_providers_project }
      else
        format.html { render :new }
        format.json { render json: @sending_providers_project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /sending_providers_projects/1
  # PATCH/PUT /sending_providers_projects/1.json
  def update
    respond_to do |format|
      if @sending_providers_project.update(sending_providers_project_params)
        if sending_providers_project_params[:set_default] == "1"
          @sending_providers_project.update_or_create_default
        end
        format.html { redirect_to project_sending_providers_projects_path(@project), notice: 'Sending services project was successfully updated.' }
        format.json { render :show, status: :ok, location: @sending_providers_project }
      else
        format.html { render :edit }
        format.json { render json: @sending_providers_project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /sending_providers_projects/1
  # DELETE /sending_providers_projects/1.json
  def destroy
    @sending_providers_project.destroy
    respond_to do |format|
      format.html { redirect_to project_sending_providers_projects_path(@project), notice: 'Sending services project was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_sending_providers_project
    @sending_providers_project = SendingProvidersProject.find(params[:id])
    @provider = @sending_providers_project.sending_provider
    @provider_key = @provider.sending_provider_keys
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def sending_providers_project_params
    params.require(:sending_providers_project).permit(
        :sending_provider_id, :project_id, :set_default, :secret_key, :public_key,
        provider_key_values_attributes: [:id, :value, :sending_provider_key_id]
    )
  end
end

app/helpers/sending_providers_projects_helper.rb
module SendingProvidersProjectsHelper

  def get_smtp_icon provider_name
    return image_tag("#{provider_name}.png", class: "rounded", style: "padding: 10px;")
  end

  def default_text is_default
    is_default ? "Current default service provider" : ""
  end

end

app/views/sending_providers_projects/_form.html.haml
= form_for [@project, @sending_providers_project] do |f|
  - if @sending_providers_project.errors.any?
    #error_explanation
      %h2= "#{pluralize(@sending_providers_project.errors.count, "error")} prohibited this sending_providers_project from being saved:"
      %ul
        - @sending_providers_project.errors.full_messages.each do |message|
          %li= message
  %div{style: "margin: 20px"}
    .custom-control.custom-checkbox{style: "margin-bottom: 20px"}
      = f.check_box :set_default, {checked: @project.has_as_default?(@sending_providers_project), class: "custom-control-input", id: "switch"}
      %label.custom-control-label.secure_font{for: "switch"}
        Is current project default? (can only be one!)

    .row
      = f.fields_for :provider_key_values, @sending_providers_project.new_values_for_keys do |nf|
        - attr_key = nf.object.sending_provider_key
        .col-md-3{"data-toggle":"tooltip", "data-placement":"top", "title":"For maximum security, this data is encrypted before it's stored in our DB"}
          %h4.secure_font
            = attr_key.key_name
            %i.material-icons security

          .field
            = nf.text_area :value, style: "width: 100%; height: 250px"
            = nf.object.new_record? ? nf.hidden_field(:sending_provider_key_id) : nil

    .actions
      = f.submit 'Save', class: "btn basic"

app/views/sending_providers_projects/edit.html.haml
= link_to '< Back', project_sending_providers_projects_path(@project)

.row{style: "margin-top: 30px"}
  .col-md-1
    = get_smtp_icon @sending_providers_project.sending_provider.name
  .col-md-11
    %h3
      Settings for
    %h2
      = @sending_providers_project.sending_provider.name

= render 'form'

app/views/sending_providers_projects/index.html.haml
%h1
  Production Service Providers
  %button.btn.btn-outline-primary.cta{"data-target" => "#serviceProvidersModal", "data-toggle" => "modal"}
    Setup new service provider

- if @sending_providers_projects.count > 0
  #serviceProvidersModal.modal.fade{"aria-hidden" => "true", "aria-labelledby" => "exampleModalLabel", :role => "dialog", :tabindex => "-1"}
    .modal-dialog.modal-lg{:role => "document"}
      .modal-content{style: "height: 400px"}
        .modal-header
          %h3#exampleModalLabel.modal-title Choose service provider
          %button.close{"aria-label" => "Close", "data-dismiss" => "modal", :type => "button"}
            %span{"aria-hidden" => "true"} ×
        .modal-body{style: "display: flex; flex-wrap: nowrap;"}
          -@unused_services.each do |provider|
            .text-center.projects{style: "flex-grow: 1; flex-basis: 0; max-width: 150px;"}
              =link_to "/projects/#{@project.id}/create_from_provider/#{provider.id}" do
                %div.project_btn
                  = get_smtp_icon provider.name
                  %h3= provider.name
                  %h5= provider.build_state

  .providers{style: "margin: 30px;"}
    - @sending_providers_projects.each do |srvc|
      .card{style: "margin-top: 10px"}
        .card-header.row{style: "margin: unset;"}
          .col-md-1
            = get_smtp_icon srvc.sending_provider.name
          .col-md-11
            %h2
              = srvc.sending_provider.name
            %h5{style: "color: #65b90f"}
              = default_text(@project.has_as_default?(srvc))
        .card-body.row
          .col-sm-2
            = link_to 'Edit', edit_project_sending_providers_project_path(@project, srvc)
          .col-sm-2
            = link_to 'Destroy', project_sending_providers_project_path(@project, srvc), method: :delete, data: { confirm: 'Are you sure?' }, class: "destroylight"

  %br
- else
  .modal-dialog.modal-lg{:role => "document"}
    .modal-content{style: "height: 400px"}
      .modal-header
        %h3#exampleModalLabel.modal-title Choose service provider
      .modal-body{style: "display: flex; flex-wrap: nowrap;"}
        -@unused_services.each do |provider|
          .text-center.projects{style: "flex-grow: 1; flex-basis: 0; max-width: 150px;"}
            =link_to "/projects/#{@project.id}/create_from_provider/#{provider.id}" do
              %div.project_btn
                = get_smtp_icon provider.name
                %h3= provider.name
                %h5= provider.build_state

app/views/sending_providers_projects/new.html.haml
%h1 New sending_providers_project

= render 'form'

= link_to 'Back', sending_providers_projects_path

app/views/sending_providers_projects/show.html.haml
%p#notice= notice

%p
  %b Sending service:
  = @sending_providers_project.sending_provider
%p
  %b Project:
  = @sending_providers_project.project
%p
  %b Is default:
  = @sending_providers_project.is_default
%p
  %b Secret key:
  = @sending_providers_project.secret_key
%p
  %b Public key:
  = @sending_providers_project.public_key

= link_to 'Edit', edit_sending_providers_project_path(@sending_providers_project)
\|
= link_to 'Back', sending_providers_projects_path